Wokrah = {}
Wokrah["ADDON_NAME"] = "Wokrah"
Wokrah["IS_PLAYER_WARLOCK"] = ({UnitClass("player")})[3] == 9
Wokrah["CURRENT_SUMMONING_PLAYER"] = nil
Wokrah["MASTER"] = UnitName("player")

WokrahAddon = LibStub("AceAddon-3.0"):NewAddon(Wokrah["ADDON_NAME"], "AceConsole-3.0")

function WokrahAddon:GetDb() -- Requires you to have a var in the toc file: ## SavedVariables: WokrahDB
    return LibStub("AceDB-3.0"):New(Wokrah["ADDON_NAME"].."DB", { 
        profile = { 
            minimap = { 
                hide = false, 
            }, 
        }, 
    }) 
end

function string.StartsWith(str, start)
    return str:sub(1, #start) == start
end

function Wokrah:PrintMsg(msg)
    local colorCodeStr = "|cff00CB72"
    local prefix = colorCodeStr.."Wokrah: |r"
    
    print(prefix..msg)
end

function Wokrah:UpdateMaster(playerName)
    local originalMaster = Wokrah["MASTER"]

    -- If we receive a master from someone else then we will update our master
    if (playerName) then
        Wokrah["MASTER"] = playerName
    -- If we haven't received a master then we will broadcast ours
    else
        WokrahComms:SyncMaster()

        -- If we don't have a master then "Look at me, I'm the master now"
        if (not Wokrah["MASTER"]) then
            Wokrah["MASTER"] = UnitName("player")
        end

        -- Validate if the master is actually in our group, if not we overrule the master anyway ;)
        if (not UnitInParty(Wokrah["MASTER"])) then
            Wokrah["MASTER"] = UnitName("player")
        end

        -- Validate if the master is online
        if (not UnitIsConnected(Wokrah["MASTER"])) then
            Wokrah["MASTER"] = UnitName("player")
        end
    end

    if (originalMaster ~= Wokrah["MASTER"]) then
        WokrahComms:SyncMaster(Wokrah["MASTER"])
        --Wokrah:PrintMsg("Current master: " .. Wokrah["MASTER"])
    end
end